
struct appdata
{
    float4 position : POSITION;
    float3 normal : NORMAL;
    //float3 color : DIFFUSE;
    float4 diffuse : DIFFUSE;
    float2 uvs :TEXCOORD0;
    float3 tangent :TEXCOORD1;
    //
	//float3 TestColor : SPECULAR;
};





struct vfconn
{

    float4 HPOS : POSITION;
    //float4 Nrm : NORMAL;
	float4 HCOL2 : COLOR1;
    float4 oPosition : TEXCOORD1;
  
};








vfconn main(appdata IN,
                uniform float3 LightPos,
                uniform float3 CameraPos,
uniform float3 alpha,
uniform float4x4 ModelViewLightProj,
uniform float4x4 ModelViewObject,
			uniform float4x4 ModelViewProj)
{
    vfconn OUT;

    
//
	//ModelViewProj=mul(ModelViewProj,ModelViewObject);
    //ModelViewLightProj=mul(ModelViewLightProj,ModelViewObject);
    //ModelViewLightProj=mul(ModelViewObject,ModelViewLightProj);

   float3 V=normalize (CameraPos-IN.position);
float dist=length(CameraPos-IN.position);
float m=1*max (dot (IN.normal,V),0);
dist*=dist;
m=pow(m,4);
m=1-m;
m*=1.3*alpha.x/dist;

  IN.position=mul(ModelViewObject,IN.position);
 OUT.HPOS = mul(ModelViewProj, IN.position);
OUT.HCOL2=IN.diffuse+float4 (1,0.4,0.1,1)*m;
//OUT.oLight=float3(0,0,-1);

//OUT.oNormal=(UpV*0.5)+0.5;

    return OUT;
} // main




























/*


  VERTEX ENV MAP



  
struct appdata
{
    float4 position : POSITION;
    float3 normal : NORMAL;
    float3 color : DIFFUSE;
    float3 TestColor : SPECULAR;
};

struct vfconn
{
    float4 HPOS : POSITION;
    float2 oPosition : TEXCOORD0;
    float2 oNormal : TEXCOORD1;
};

vfconn main(appdata IN,
            uniform float3 Kd,
            uniform float4x4 ModelViewProj)
{
    vfconn OUT;

    

	OUT.HPOS = mul(ModelViewProj, IN.position);
float3 normal=mul((float3x3)ModelViewProj,IN.normal);
normalize(normal);


float4 normpos=normalize(OUT.HPOS);
float3 refl=reflect (normal,normpos);


float magn=1.5*sqrt (refl.x*refl.x+refl.y*refl.y+(refl.z+1)*(refl.z+1));






float4 normpos2=normalize(IN.position);
float3 refl2=reflect (IN.normal,normpos);


float magn2=1.5*sqrt (refl2.x*refl2.x+refl2.y*refl2.y+(refl2.z+1)*(refl2.z+1));




//diss/=length(diss);


//float cl=dot (normal,diss-OUT.HPOS);
OUT.oNormal.x=refl.x/magn+0.5;
OUT.oNormal.y=refl.y/magn+0.5;


//normalize(diss);

OUT.oPosition.x=IN.position.x*2;
OUT.oPosition.y=IN.position.y*2;

//OUT.oNormal.x=normal.x*0.3;
//OUT.oNormal.y=normal.y*0.3;

    return OUT;
} // main

 */
